{
    gROOT->Reset();
    gROOT->Time();


    Float_t x;
    Float_t z;
    Float_t dist;
    Int_t num = 0;
    Int_t i;
    
    const Float_t kMomX = 0.08;
    const Float_t kMomZ = 0.08;

    TPhHit *hit;
    TPhStuff *stuff = new TPhStuff();

    TPhIdealMagnet *magnet = new TPhIdealMagnet();
    TPhDetector *det  = new TPhDetector();

    const Char_t *phathome = gSystem->Getenv("PHATHOME");
    printf("Found PHAT home at %s\n",phathome);

    Char_t pathname[256];
    sprintf(pathname,"%s/init/test.2d", phathome);
    det->ReadASCIIGeometry(pathname);


    TPhSwim   *swim = new TPhSwim();
    swim->SetMagnet(magnet);
    swim->SetDetector(det);
    swim->SetMS(kFALSE);
    swim->SetPixelize(kFALSE);


    TrueTrack = new TPhTrack();
    TrueTrack->SetPx(kMomX);
    TrueTrack->SetPz(kMomZ);
    TrueTrack->SetPy(0);
    TrueTrack->SetMass(0.139);
    TrueTrack->SetCharge(1);
    swim->SwimTrack(TrueTrack);
     
    det->Draw();
    TrueTrack->Draw(2);

    TPhTrackTemplate *t = new TPhTrackTemplate(16);
    t->FillTrack(TrueTrack,kFALSE);
    t->ReadCovar("test.covar");
    t->PrintCovar();

    swim->SetMS(kTRUE);
    swim->SetPixelize(kTRUE);
    swim->SetVerbose(0);      
    
/*
    TH1F chi2H("chi2H","Chi2 disttribution",100,0,100);
    TH1F probH("probH","Probability disttribution",100,0,1);
    TCanvas c2("c2");
    probH.SetMarkerStyle(20);
*/

    Float_t chi2;
    Float_t ndof;
    Float_t prob;

    for(i=0;i<1000;i++)
    {
        track = new TPhTrack();
        track->SetPx(kMomX);
        track->SetPz(kMomZ);
        track->SetPy(0);
        track->SetMass(0.139);
        track->SetCharge(1);
        swim->SwimTrack(track);
        t->CalcChi2(track,1);
//        chi2H.Fill(track->GetChi2());
        chi2 = track->GetChi2();
        ndof = track->GetNDof();
        prob = stuff->GetProb(chi2,ndof);
        if(prob < 0.01)
           track->Draw(4);
/*
        probH.Fill(prob);
        if(!(i%100))
        {
            probH.Draw("e1p");
            c2.Update();
        }
*/
    }
}

