// Simple 3D event display of a GEANT event.
//
//Begin_Html <A HREF="mailto:decowski@mit.edu">decowski@mit.edu</A>
//End_Html
{
    gROOT->Reset();

    TPhHit    *hit;
    TPhEvent  *event;

    TObjArray *HitList;
    TObjArray *TrackList;
    TPhTrack  *track;

    // Get the detector object. 
    // tracks through the detector
    Char_t FileName[256];
    sprintf(FileName,"%s/init/test/Detector.root", 
            gSystem->Getenv("PHATHOME"));
    TFile f(FileName);
    // Get version 4.2
    TPhDetector *det = f.Get("PMC_V4.20");
    f.Close();

    // Draw the Canvas
    TCanvas c2("view");

    // Open the data file. 
    // As with all Phat stuff, PHATHOME envrionment has to be defined and 
    // pointing to the main Phat directory
    //
    // FIRST convert the APX file into PhAT format!
    sprintf(FileName, "%s/data/cv0_00000e1.apx.root", 
            gSystem->Getenv("PHATHOME"));
    TPhDST *dst = new TPhDST(FileName);

    event = dst->GetNextEvent();
    TrackContainer = 
      (TPhObjectContainer*) event->GetObject("MCTracks");

    // Draw detector
    det->Draw();

    // Draw all the tracks 
    TrackContainer->Draw();
}
