// Make a detector from an AOU geometry
//
//Begin_Html <A HREF="mailto:decowski@mit.edu">decowski@mit.edu</A>
//End_Html
//
// $Id: make_detector.C,v 1.6 1998/12/16 17:53:53 katzy Exp $
{
  gROOT->Reset();
  const Char_t *phathome = gSystem->Getenv("PHATHOME");
  if(!phathome) {
    printf("You MUST have an environmental called PHATHOME!\n");
    return;
  }

  Char_t FileName[256];
  // This is the AOU file where we get our geometry from
  //  sprintf(FileName,"%s/data/cv0_00000e1.apx", phathome); 
  // changed it to the new default file name (jk,12/16/98)
  sprintf(FileName,"%s/data/cv0_1.aou", phathome); 
  TPhASCIIData *data = new TPhASCIIData(FileName);

  sprintf(FileName,"%s/init/test/Detector.root", phathome); 
  f = new TFile(FileName, "UPDATE");
  if(!f->IsOpen()) f = new TFile(FileName, "RECREATE");
  if(!f->IsOpen()) {
    printf("Couldn't open the Detector.root file\n");
    exit(0);
  }
  // This call is needed to fetch the detector geometry from the AOU
  // file. we don't do anything with the event. 
  data->GetNextEvent();
  TPhDetector *detector = TPhDetector::GetInstance();
  detector->Write();

  //Write this detector version also with a standard name
  detector->Write("LatestGeometry");

  printf("Got detector geometry %s from AOU and wrote it into %s\n", 
	 detector->GetName(), FileName);
  f.Close();
}
