// Mul.C  Multiplicity processor, simple demo version for phatonl.
//   (this is not the 3-plot version used in MDC1)    D. McLeod 16-Jan-1999
//  This version works with Phat.15Jan1999
//***********************************************************************
//  Mul.C function wrapper:
void Mul(Int_t phase = 0, Int_t dflag = 0)
{
  if (ReportLevel >= 3) {
       printf("Mul entered, phase = %d, dflag = %d\n",phase,dflag);
  }

  if(phase == kIni1) {
    if (ReportLevel >= 3) printf("Mul initialization\n");
    // The following should really be done after the initialization call
    // mp.Process(ev, -1) but will probably work; resetting displays would NOT
    // work because they have not yet been created. 
    mp.fDataSource = dataSource;
    strcpy(ptype,"LEGO2");  // default plot type
  } // end of initialization phase wrapper
  //******************************************************************
  if(phase == kRun3) {
     mp.SetVertex(v1);
     if (ReportLevel >= 3) {
       if(v1) printf("Vertex at %f %f %f\n",v1->GetX(),v1->GetY(),v1->GetZ());
       else if (ReportLevel >= 3)printf("v1??, what v1?");
     }
 
       mp.Process(ev);
       if (ReportLevel >= 3) printf("EV loop: af mp.Process(ev)\n");

       // Get display graph: (flMul condition is to avoid clearing one-shot pix)
       if(flMul == 1 || flMul == 2) {
       if(dg) dg->Delete();
       if (ReportLevel >= 3) printf("EV loop: delete dg\n");
       dg = mp.GetHist(dName,dSelector,dind,dinde,360);
       // 18-Jan-99 on CVS, 26-Jan on phowl, removed the -1 again!
       // 17-Jan-99:  Added iMap arg (-1); source code for TPhMulDisp
       // implies -1 means don't override dSelector.  Need to interface
       // to TPhMulDisp as the next step in Mul.C development.
       //   dind & dinde may be altered by buttons; dSelector can be
       // made alterable also by adding buttons.

       if (ReportLevel >= 3)printf("EV loop: mp.GetHist called\n");
       }

       // Create MapSets for output tree (and DST, if outFile != 0)

     Int_t iErr = 0;
     if (mOpts) iErr = gROOT->Macro(mMacroName);
     if (iErr && ReportLevel >= 2)
       printf ("writemul.C returned error code %d.\n", iErr);

  }  // end of run phase wrapper
  //******************************************************************
  if(phase == kDis3) {
    if (ReportLevel >= 3) printf("MUL:starting display\n");
    if(flMul == 1 || flMul == 2) {
       cmul = new TCanvas("cmul", "Multiplicity", 200, 100, 700, 700);
       if( dg ) dg->Draw(ptype);
       cmul->Update();
    }
    if(flMul == 3) { cmul->Close(); barg->Close(); barg = NULL; }
    // barg is the Mul mode selecting button bar
    if(flMul == 1) flMul = 4;   // part of handling single or repeating
    if(flMul == 3) flMul = 0;   // displays.  See phatsetonl.C.
  }  // end of display phase wrapper
}  // end of Mul.C




