// Out.C  MDC1 tree output for phatloop.C; now extended for phatonl.C
//
// DMcL    16-Feb-99 Added code for new Vertex diagnostics and
//                   output of TPhOnSensorContainer object
// MDB     12-Feb-99 Draft 1 of the MDC2 code.
// DMcL    30-Jan-99 Extend for MDC2&ONL. Added Out.h
// MDB     15-SEP-98 Extend tree to include SPC
// DMcL    12-SEP-98 minor edits
// AT/MDB  09-SEP-98 MDC1 Output
//

void Out(Int_t phase = 0, Int_t dflag = 0)
{
  if (ReportLevel >= 3) {
    printf("Out entered, phase = %d, dflag = %d\n",phase,dflag);
  }

  //  INITIALIZATION OF MDC1 DST OUTPUT
  if(phase == kIni1 && MDC1flag) {
    fout = new TFile(OuFile,"RECREATE","A Tree DST",0);
    if(!fout) {
      printf("FATAL.. OuFile,\, expanded name = %s, can't open!\n",
          gSystem->ExpandPathName(OuFile));
      gSystem->Abort();
    }
    else {
      printf("OuFile,\, expanded name = %s, created!\n",
         gSystem->ExpandPathName(OuFile));
    }
    //     fout->SetCompressionLevel(2);
    fout->ls();
    ftree = new TTree("DST","PHOBOS Output DST Tree");
    if (ReportLevel >= 3) printf("Tree created\n");
    ftree->Branch("header",&fhead,"runnum:evnum:mult");
    ftree->Branch("vertex",&frvtx,"xv:yv:zv");
    ftree->Branch("trkhead",&ftrkhd,"Ntracks:Ntemplates");
    ftree->Branch("Occ","TH2F",&dg[2],128000,0);
    ftree->Branch("dNdeta","TH2F",&dg[1],128000,0);
    ftree->Branch("dNdetadphi","TH2F",&dg[0],128000,0);
    ftree->Branch("VtxObject","TPhVertex",&v1,32000,0);
    ftrkhd.Ntracks = 0;
    ftrkhd.Ntemplates = 0;
    //    if (doSpc) {
    //  ftree->Branch("
    // }
    if (ReportLevel >= 3) printf("End of Out Initialization\n");
  }  // END MDC1 INITIALIZATION

  //  INITIALIZATION OF MDC2 DST OUTPUT  
  if(phase == kIni1 && MDC2flag) {
    fout = new TFile(OuFile,"RECREATE","A Tree DST",0);
    if(!fout) {
      printf("FATAL.. OuFile,\, expanded name = %s, can't open!\n",
          gSystem->ExpandPathName(OuFile));
      gSystem->Abort();
    }
    else {
      printf("OuFile,\, expanded name = %s, created!\n",
         gSystem->ExpandPathName(OuFile));
    }
    //    fout->SetCompressionLevel(1);
    fout->ls();
    ftree = new TTree("DST","PHOBOS Output DST Tree");
    if (ReportLevel >= 3) printf("Tree created\n");
    ftree->Branch("header",&fhead,"runnum:evnum:mult:dmult:multru:dmultru");
    ftree->Branch("trkhead",&ftrkhd,"Ntracks:Ntemplates");
    ftree->Branch("vertex",&frvtx,"xv:yv:zv:vtxval:vtxerr");
    ////ftree->Branch("vertex",&frvtx,"xv:yv:zv");
    if (doVtx >= 1) ftree->Branch("VtxObject","TPhVertex",&v1,32000,0);
    if (doMul >= 1) {
      ftree->Branch("mhisthr-1","TH2F",&mHists[0],128000,0);
      ftree->Branch("mhistin-1","TH2F",&mHists[1],128000,0);
      ftree->Branch("mulgraf0","TGraphErrors",&mGraphs[0],128000,0);
      ftree->Branch("mulgraf1","TGraphErrors",&mGraphs[1],128000,0);
      ftree->Branch("mulsmap","TPhMapSet",&sms1,128000,0);
      ftree->Branch("muldmap","TPhMapSet",&dms1,128000,0);
    }

    ftrkhd.Ntracks = 0;
    ftrkhd.Ntemplates = 0;
    fhead.mult = 0.0;
    fhead.dmult = 0.0;
    fhead.multru = 0.0;
    fhead.dmultru = 0.0;
    frvtx.xv = 0.0;
    frvtx.yv = 0.0;
    frvtx.zv = 0.0;
    frvtx.vtxval = kFALSE;
    frvtx.vtxerr = 0;
    //    if (doSpc) {
    //  ftree->Branch("
    // }
    if (ReportLevel >= 3) printf("End of Out Initialization\n");
  }  // END MDC2 INITIALIZATION

  //  INITIALIZATION OF ONLINE DST OUTPUT  
  if(phase == kIni1 && ONLflag) {
    //  This is planned to be special for Online monitoring
  }  // END ONLINE DST INITIALIZATION

  //  INITIALIZATION OF TPhOnSensor etc. output  
  if(phase == kIni1 && ADCflag) {
    //  Just TPhOnSensor for now; may be absorbed into ONLINE DST
    //  File ADCFile is chosen in uset.C & opened in the final phase only
  }  // END INITIALIZATION OF TPhOnSensor etc. output

  //  RUN LOOP, MDC1
  if(phase == kRun1 && !iev==0 && MDC1flag) { 
  // MDB/AT Screw up the whole 0th event for everybody as MUL has done.

     if(iev%ReportFreq==0 && ReportLevel >=2 && iev )  ftree->Print(); 
     //  The above was moved from phat.C just before Vtx.C call   DMcL

    if (v1) {
      frvtx.xv=v1->GetX();
      frvtx.yv=v1->GetY();
      frvtx.zv=v1->GetZ();      
      if (ReportLevel >= 2) printf("zv after GetZ: %f\n",frvtx.zv);
    }
    else {
      if (ReportLevel >= 2) printf("Oops. Where's v1?\n");
    }
    fout.cd();
    if (ReportLevel >= 2) fout.ls();

    fhead.runnum=ev->GetNRun();
    fhead.evnum=iev;
    // MDB 10SEP98 Normalization guess : 12 units of eta / 48 bins = 0.25 
    if (dg[1]) fhead.mult = 0.25*dg[1]->Integral(1,48,1,1);
    if (ReportLevel >= 2) {
      printf("Run # = %d,  Event # = %d\n", fhead.runnum, fhead.evnum);
      if (dg[1]) printf("Mult = %f\n", fhead.mult);
    }
    if (ReportLevel >= 3) printf("OUT:ptrs: dg[0],dg[1]:%d,%d\n",dg[0],dg[1]);
    if (doSpc) {
      ftrkhd.Ntracks=ntrfound;
      ftrkhd.Ntemplates=templtested;
    }
    ftree->Fill();
    if(iev%ReportFreq==0 && ReportLevel >=2 && iev) ftree->Print();
    if (ReportLevel >= 3) {
      printf("post-fill\n");
      //      ftree->Print();
    } 
  } // END RUN LOOP, MDC1

  //  RUN LOOP, MDC2 DST OUTPUT
  if(phase == kRun1 && !iev==0 && MDC2flag) { 
  // MDB/AT Screw up the whole 0th event for everybody as MUL has done.

     if(iev%ReportFreq==0 && ReportLevel >=2 && iev )  ftree->Print(); 
     //  The above was moved from phat.C just before Vtx.C call   DMcL

    if (v1) {
      frvtx.xv=v1->GetX();
      frvtx.yv=v1->GetY();
      frvtx.zv=v1->GetZ();      
      frvtx.vtxval=v1->IsValid();   // Added for P.D. new methods; also
      frvtx.vtxerr=v1->GetStatus(); // see Out.h for structure expansion

      if (ReportLevel >= 2) printf("zv after GetZ: %f\n",frvtx.zv);
    }
    else {
      if (ReportLevel >= 2) printf("Oops. Where's v1?\n");
    }
    fout.cd();
    if (ReportLevel >= 2) fout.ls();

    fhead.runnum=ev->GetNRun();
    fhead.evnum=iev;
    if (doMul >= 1) {
      fhead.mult=nChRec;
      fhead.dmult=nChRecRMS;
      fhead.multru=nChGen;
      fhead.dmultru=nChGenRMS;
    }
    if (ReportLevel >= 2) {    
      printf("Run # = %d,  Event # = %d\n", fhead.runnum, fhead.evnum);
      printf("Mult = %f +/- %f\n", fhead.mult, fhead.dmult);
    }
    if (ReportLevel >= 3) {
       printf("OUT:mulptrs: sms1,dms1: %d,%d\n",sms1,dms1);
       printf("OUT:mulptrs: hist. 0,1: %d,%d\n",mHists[0],mHists[1]);
       printf("OUT:mulptrs: graph 0,1: %d,%d\n",mGraphs[0],mGraphs[1]);
    }
    if (doSpc) {
       ftrkhd.Ntracks=ntrfound;
       ftrkhd.Ntemplates=templtested;
    }
    ftree->Fill();
    if(iev%ReportFreq==0 && ReportLevel >=2 && iev) ftree->Print();
    if (ReportLevel >= 3) {
      printf("post-fill\n");
      //      ftree->Print();
    } 
  } // END RUN LOOP, MDC2

  //  RUN LOOP, ONLINE DST OUTPUT
  if(phase == kRun1 && !iev==0 && ONLflag) { 
    // Nothing here yet
  } // END RUN LOOP, ONLINE DST OUTPUT

  //  RUN LOOP, TPhOnSensor etc. output
  if(phase == kRun1 && !iev==0 && ADCflag) { 
    //  At present, no actions during the run phase
  } // END RUN LOOP, TPhOnSensor etc. output

  //  DISPLAY
  if(phase == kDis3 && ReportLevel >= 3 ) {
     printf("Nothing to display in Out\n");
  }
  //  FINAL MDC1 OUTPUT
  if(phase == kFin1 && MDC1flag) {
     if (ReportLevel >= 1) printf("Out.C:Writing out the tree.\n");
       fout.Write();
       fout.Close();
     if (ReportLevel >= 1) printf("Out.C:Done writing out the tree.\n");
  } // END FINAL MDC1 OUTPUT

  //  FINAL MDC2 OUTPUT
  if(phase == kFin1 && MDC2flag) {
     if (ReportLevel >= 1) printf("Out.C:Writing out the tree.\n");
       fout.Write();
       ////fout.Close();  // Commented out, TPhOnSensorContainer coming
     if (ReportLevel >= 1) printf("Out.C:Done writing out the tree.\n");
  } // END FINAL MDC2 OUTPUT

  //  FINAL ONLINE DST OUTPUT
  if(phase == kFin1 && ONLflag) {
    // Nothing here yet  
  } // END FINAL ONLINE DST OUTPUT

  //  FINAL TPhOnSensor etc. output
  if(phase == kFin1 && ADCflag) {
    //  Output the tt instance of TPhOnSensorContainer
    if(!tt) {
       printf("There is no tt instance of TPhOnSensorContainer. Onl not clicked??\n");
       return;
    } 
    ////TFile fadc(ADCFile,"RECREATE");
    fout.cd();
    tt->Write();
    fout.Close();
    printf("Wrote TPhOnSensorContainer instance tt to DST file"); 
  } // END FINAL TPhOnSensorCOntainer output
}      //  end of Out.C 







