main()
{
// Clean the ROOT environment 
    gROOT->Reset();
    gROOT->Time(); 
   
// Get the directory where we sit in
   const Char_t *phathome = gSystem->Getenv("PHATHOME");
   printf("Found PHAT home at %s\n",phathome);

// Create some histograms

   TH1F mom("mom","tot. momentum of reconstructed ptls",120,0.0,1.2);
   TH1F theta("theta","theta distribution",80,10.,90.);

   // Get detector object from AOU file 
   Char_t FileName[512], TemplFileName[512];
   Char_t AOUFileName[512];
   Char_t PSFileName[512], HeaderText[512];

   sprintf(AOUFileName,"swim1p45pipIDEAL.aou","");
   printf("========= Detector from file: %s =========\n", AOUFileName);

   TPhASCIIData *data = new TPhASCIIData(AOUFileName);
   data->ReadASCIIHeader(AOUFileName);
   delete data;

   sprintf(AOUFileName,"swim1p45pipPIXDE.aou","");
   data = new TPhASCIIData(AOUFileName);

   TPhDetector *det = TPhDetector::GetOrCreateInstance();

//   det->Print();

   printf("detector version : %f \n",det->GetVersion());

    Int_t num = 0;
    Int_t i;
    Int_t j;
    Int_t ok,lo;
    Float_t r2d=180./4./atan(1.);


// Create a few important objects

    TPhTemplateManager *tman  = new TPhTemplateManager();
    TPhTrackSelector   *tsel  = new TPhTrackSelector();

  tman->SetVerbose(1);

   printf("Start reading templates\n");

  tman->ReadTemplateList("templ_400_500_5.root");
  TObjArray  *TemplateList;

  TPhTrackTemplate *ttemp;

   printf("Get template list\n");

  TemplateList = tman->GetTemplateList();
//   printf("Loop over templates\n");
  for(i=0;i<TemplateList->GetEntries();i++)
    {
      ttemp = (TPhTrackTemplate  *)TemplateList ->At(i);
 //     printf("Px Pz %f %f %f \n",  ttemp ->GetP(),ttemp ->GetPx(),ttemp ->GetPz());
    }
  
  Float_t x;
  Float_t px;
  Float_t pz;
  Float_t max_prob;
  Float_t best_p;   
  
  TPhEvent   *event;
  TObjArray  *tracklist;
  TPhMCTrack *mctrack;
    TPhObjectContainer *pmctracks;
  TPhTrack   *track;
  TPhMCHit   *hit;
  TPhHit  *dethit;
    TPhObjectContainer *hits;
    TPhHashContainer *hitarrays;
  Char_t *name;

  tman->SetVerbose(0);
  tsel->SetVerbose(0);
  
  TObjArray  *TrackList;

  printf("start processing events\n");

    while(event = data->GetNextEvent() && num < 200)
    {
	printf("Processing new Event %d \n\n",num);
        det->SetEvent(event);
        det->FillWithEventHits("MCHits");  // this does not work !?
        det->MakeHitArraysOutOfHits("MCHits","HitArrays");
        event->Print();

      pmctracks =      (TPhObjectContainer*) event->GetObject("MCTracks");
      hits   =      (TPhObjectContainer*) event->GetObject("MCHits");
      hitarrays   = (TPhHashContainer*) event->GetObject("HitArrays");
      printf("Event %d: %d tracks %d hits %d hitarrays\n",
             event->GetNEvent(), pmctracks->GetEntries(),
             hits->GetEntries(),
             hitarrays->GetEntries());

        mctrack = (TPhMCTrack *) pmctracks->GetObjectList()->At(0);

//        TIter NextHitA(mctrack->GetHitList());
//        while(hit = (TPhMCHit *) NextHitA())
//        {
//           printf("plane %4d  x = %9.2f  z = %9.2f\n", hit->GetLayer(), hit->GetX(), hit->GetZ());
//        }
//        printf("first track info listed\n");

        for(i=0; i < hits->GetEntries(); i++)
        {
            hit = (TPhMCHit *) hits->GetObjectList()->At(i);
//            printf(" hit %3d is in layer %d  z = %f\n", i,  hit->GetLayer(),  hit->GetZ());
            det->AddHit(hit);
        }

	tman->CreateTrackCandidates();
	printf("Found %d candidates\n", tman->GetCandidateList()->GetEntries());

	tsel->SelectTracks(tman->GetCandidateList());
	
	tracklist = tsel->GetTrackList();
	printf("Found %d tracks\n",tracklist->GetEntries());
	for(i=0;i<tracklist->GetEntries();i++)
	{
	    track = (TPhTrack *) tracklist->At(i);
	    mom->Fill(track->GetP());
	    theta->Fill(atan(track->GetPx()/track->GetPz())*r2d);
	    printf("Found track %g (%g , %g , %d)\n",track->GetP(),track->GetPx(),track->GetPz(),track->GetCharge());
	}
	  
	det->DeleteHits();
        tman->GetCandidateList()->Delete();
        delete event;
	num++;
    }


delete det;

     mom.DrawCopy();
//     TText *text = new TText(0.11,0.35,"1000 initial particles were `p#^+! with ");
//     text->SetTextSize(0.03);
//     text->Draw();
   
//     theta.DrawCopy();

   c1->Modified();
   c1->cd();
}
