#ifndef _TPhAbsDataContainer_INCLUDED_
#define _TPhAbsDataContainer_INCLUDED_

//////////////////////////////////////////////////////////////////////////
//                                                                      //
//    TPhAbsDataContainer                                               //
//                                                                      //
//    Abstract Phobos data container class. Raw data and the results of //
//    calibration and reconstruction operations are stored in           //
//    Data Containers. There are currently two implementations of the   //
//    datacontainers:                                                   //
//          1. TPhObjectContainer for classes not deriving from TNamed  //
//          2. TPhHashContainer  for classes that derive from TNamed    //
//                                                                      //
//    Author  : Patrick Decowski                                        //
//    Created : March 09 1998                                           //
//    Version : 1.0                                                     //
//    Changed :                                                         //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

// Root Classes
#include "TIterator.h"

// Phobos Classes
#include "TPhDataObject.h"

class TPhAbsDataContainer : public TPhDataObject {

public:
    virtual void       Add(TObject *object) = 0;
    virtual TIterator* GetIterator(Bool_t dir = kIterForward) = 0;
    virtual Int_t      GetEntries() = 0;

    virtual void       ls(Option_t *option) = 0;
    virtual void       Draw(Option_t *option) = 0;
    virtual void       Print(Option_t *option) = 0;

    ClassDef(TPhAbsDataContainer,1)    // Abstract Container Class

};

#endif




