#ifndef _PhPoint_INCLUDED_
#define _PhPoint_INCLUDED_

///////////////////////////////////////////////////////////////////////
//                                                                   //
//    TPhPoint                                                       //
//                                                                   //
//    Phobos Point class                                             //
//                                                                   //
//    TPhPoint is the standard PHOBOS point class used in the PR     //
//    programs as basis for 3D points, hits etc                      // 
//                                                                   //
//    Author  : Gunther Roland (rolandg@vxcern.cern.ch)              //
//    Created : 01/09/96                                             //
//    Version : 1.0                                                  //
//    Changed :                                                      //
//                                                                   //
///////////////////////////////////////////////////////////////////////

// Root Classes

#include "TObject.h"

// Phobos Classes


class TPhPoint : public TObject {

public:
    TPhPoint() { };
    
    virtual ~TPhPoint() { };

    virtual Double_t  GetX()            { return fX;         }
    virtual Double_t  GetY()            { return fY;         }
    virtual Double_t  GetZ()            { return fZ;         }
 
    virtual void     SetX(Double_t x)   { fX = x;            }
    virtual void     SetY(Double_t x)   { fY = x;            }
    virtual void     SetZ(Double_t x)   { fZ = x;            }

  
private:

    Double_t   fX;           // X position                
    Double_t   fY;           // Y position                
    Double_t   fZ;           // Z position                

public:

    ClassDef(TPhPoint,1) // PHOBOS space point class

};

#endif

