#ifndef _PhRecMCHit_INCLUDED_
#define _PhRecMCHit_INCLUDED_

///////////////////////////////////////////////////////////////////////
//                                                                   //
//    TPhRecMCHit                                                    //
//                                                                   //
//    Author  : Krzysztof Wozniak                                    //
//    Created : 22/11/1998                                           //
//    Version : 1.0                                                  //
//    Changed :                                                      //
//                                                                   //
///////////////////////////////////////////////////////////////////////

// Root Classes

#include "TObject.h"

#include <string.h>

// Phobos Classes


#include "TPhHit.h"
#include "TPhMCHit.h"
#include "TPhTrack.h"


class TPhRecMCHit : public TPhMCHit {

public:
    TPhRecMCHit();
    TPhRecMCHit(TPhHit *rawhit);
    TPhRecMCHit(TPhMCHit *mchit);

    virtual ~TPhRecMCHit() { }

    virtual void     SetNPads(Int_t n)      {  fNPads = n;     }

    virtual Int_t    GetNPads()             {  return fNPads;  }

    virtual void     SetX(Float_t x)        {  TPhHit::SetX(x);  fDist45 = 0.0;  }
    virtual void     SetZ(Float_t z)        {  TPhHit::SetZ(z);  fDist45 = 0.0;  }
    virtual Float_t  CalcDist45();

    virtual void     Print(Option_t *option = "");
    virtual void     ls(Option_t *option = "");

protected:

    Int_t        fNPads;               // Number of pads merged together
    Float_t      fDist45;              // Distance to the hit from 45 deg line

public:

    ClassDef(TPhRecMCHit,1)  // PHOBOS merged hit data class

};

#endif
