{ // readmaps.C: Phat macro to read TPhMapSets
// Use:
//  .x writemaps.C
// 31-Jan-99 First version
// Status: OK; sensor maps report none active; get segv when rerun

//  TPhMul &mu = mp;

  Int_t   maxReply = 128;
  Int_t   maxMName = 20;
  Char_t  mapFile[maxReply]; // input .root file
  Char_t  dispMapName[maxMName]; // name of display MapSet object in file
  Char_t  sensMapName[maxMName]; // name of sensor MapSet object in file

  strncpy (mapFile, "hij50maps.root", maxReply);
  strncpy (sensMapName, "sensors", maxMName);
  strncpy (dispMapName, "displays", maxMName);

  Int_t   nDispMaps = 0;
  Int_t   nSensMaps = 0;
  Char_t *openOpt = "read"; // new or create, recreate, update, read

  Int_t   iPrint = 0;
  Int_t   nErrs = 0;
  Int_t   reportLevel = 3;
  Int_t   nPrint = 10;
  Char_t  reply[maxReply+1];
  Bool_t  interact = kTRUE;

// Set options interactively

  if (interact)
  { printf ("Input file name (cr = %s)? ", mapFile);
    if (fgets(reply, maxReply, stdin))
    { if (reply[0] != '\n')
      { strncpy(mapFile, reply, maxReply);
        mapFile[strlen(reply)-1] = 0;
      }        
    }
  } // if (interact

// Create display and sensor MapSets

  TPhMapSet *dms1 = new TPhMapSet();
  if (dms1)
  { nDispMaps = dms1->GetNMapsAct();
    if (reportLevel >= 3)
      printf ("readmaps.C: found %d active display maps.\n", nDispMaps);
  }
  else
    if (reportLevel > 0)
      printf ("readmaps.C: unable to create display MapSet.\n");

  TPhMapSet *sms1 = new TPhMapSet(1);
  if (sms1)
  { nSensMaps = sms1->GetNMapsAct();
    if (reportLevel >= 3)
      printf ("readmaps.C: found %d active sensor maps.\n", nSensMaps);
// Kludge until we find out why there are no sensor maps
    nSensMaps = sms1->GetNMaps();
    if (reportLevel >= 3)
      printf ("readmaps.C: found %d active sensor maps.\n", nSensMaps);
  }
  else
    if (reportLevel > 0)
      printf ("readmaps.C: unable to create sensor MapSet.\n");

// Read TPhMapSets from input file

  TFile ff(mapFile, openOpt);

  if (interact)

  { ff->ls();

    printf ("Display mapset object name (cr = %s)? ", dispMapName);
    if (fgets(reply, maxMName, stdin))
    { if (reply[0] != '\n')
      { strncpy(dispMapName, reply, maxMName);
        dispMapName[strlen(reply)-1] = 0;
      }        
    }
    printf ("Sensor mapset object name (cr = %s)? ", sensMapName);
    if (fgets(reply, maxMName, stdin))
    { if (reply[0] != '\n')
      { strncpy(sensMapName, reply, maxMName);
        sensMapName[strlen(reply)-1] = 0;
      }        
    }
  } // if (interact

  if (dms1)
  { dms1->Read(dispMapName);
    nDispMaps = dms1->GetNMapsAct();
  }

  if (sms1)
  { sms1->Read(sensMapName);
    nSensMaps = sms1->GetNMapsAct();
  }

  if (reportLevel >= 2)
  { printf ("readmaps.C: read %s containing %d maps.\n",
      mapFile, nDispMaps + nSensMaps);
    printf ("The sensor mapset is sms1, the display mapset, dms1.\n"
     "Do   m1 = dms1->GetMap(\"*+in\")   to get display map m1.\n");
  }
}
