#ifndef __TPhOnSensorContainer__
#define __TPhOnSensorContainer__


#include "TPhOnContainer.h"

class TObjArray;
class TCanvas;
class TPad;
class TPhDetector;
class TPhSubDetector;

class TPhOnSensorContainer : public TPhOnContainer { 

public:
  TPhOnSensorContainer();
  TPhOnSensorContainer(const Char_t *Name);
  Int_t          Init(Option_t *option = "all" );
  Int_t          Init(TPhSubDetector *subdetector);
  void           Fill(Option_t *option = "all");
  Int_t          Fill(TPhSubDetector *subdetector);
  void           Reset();
  void           Draw(Char_t *sname, Option_t *opthist);
  void           Draw(Char_t *sname);
  void           ListHisto(Option_t *option = "ALL");
  Bool_t         Check(Option_t *option = "ALL");
  Bool_t         Check(Char_t *sname, Option_t *option);

  
  ~TPhOnSensorContainer();


protected:
  TPhDetector  *fDetector;     //! The detector object

  ClassDef(TPhOnSensorContainer,1)  // online container for sensor based histos

};

#endif // __TPhOnSensorContainer__ 


