void phatset(Char_t* act = "", Int_t phase = 1) {
//  phaticonl.C brings up a button panel; button presses usually call
//  phatsetonl.C with "act" corresponding to which button. This allows
//  actions which would make a too-long button action string. 2nd arg.
//  phase = phase of phatonl.C as in phaticonl; 1 = init, 2 = run, 3 = end.

//     Edited for phatonl.C use 12/12/98... file name changed.  DMcL
//  Changed to alph. act code 09-Jan-1999 for more flexibility for additions
//     28-Jan-1999: Got file selector box from dialogs.C working & installed
//     in Output button actions; code is copied with alterations. 
//     31-Jan-1999: Changed exflag to local function call to ensure
//     little red "EXECUTE" is written on the proper pad         DMcL

  //  Any button pushed -> set display flag doDisp for loops:
  doDisp = 1;

////////////////  Standard "housekeeping" buttons:  /////////////////////

//  UNFORTUNATELY 9/3/98... unable to find why dialog boxes crash the
//  subsequent Phat operations... revert to dialogue in ROOT via stdin
//  & stdout... leave the nice stuff commented out & return to it later.

  //   Some definitions needed for this kluge:
  Int_t nevents = 50000;
  Int_t nruns = 10000;
  Int_t MaxReply = 100;
  Char_t reply[MaxReply];

  Char_t inF[MaxReply];

  // select the input file with a ugui GUI with 3 choices:
  if(phase == 1 && !strcmp(act,"Input")) ugui("Input",1);  

  // select the output file with a file selector box:
  if(phase == 1 && !strcmp(act,"Output")) {
     gSystem->ChangeDirectory(gSystem->Getenv("HOME"));
     //  Modified code from root/tutorials/dialogs.C:
     const char *gSaveAsTypes[] = {
        "ROOT files",   "*.root",
        "All files",    "*",
         0,              0
     };
     static TGFileInfo fi;
     fi.fFileTypes = gSaveAsTypes;
     new TGFileDialog(gClient->GetRoot(), gClient->GetRoot(), kFDSave, &fi);
     if(fi.fFilename == NULL) return; // CANCEL button pushed 
     strcpy (OuFile,gSystem->WorkingDirectory());
     strcat (OuFile,"/");
     strcat (OuFile,fi.fFilename);  
     printf("Output file set to expanded name = %s\n",
     gSystem->ExpandPathName(OuFile));
  }    

  if(phase == 1 && !strcmp(act,"Events")) {
    printf(">>>>>>>>><<<<<<<<<<\nNumber of events to process?\n");
    if (fgets(reply, MaxReply, stdin)) {
      if (reply[0] != '\n') sscanf (reply, "%d", &nEvents);
    }
    //  A coupleof unsuccessful attempts... both cause seg viol in event loop
    //nevents = GetIntegerDialog("Give number of events:", 10000);
    //nEvents = atoi(strdialog("# of events","10000"));
    printf(" Number of events selected = %d\n",nEvents);
 }

  if(phase == 1 && !strcmp(act,"Runs")) {
    printf(">>>>>>>>><<<<<<<<<<\nNumber of runs to process?\n");
    if (fgets(reply, MaxReply, stdin)) {
      if (reply[0] != '\n') sscanf (reply, "%d", &nruns);
    }
    //   nruns = GetIntegerDialog("Give number of runs:", 10000);
    nRuns = nruns; 
    printf(" Number of runs selected = %d\n",nruns); 
  }

  if(phase == 1 && !strcmp(act,"GO")) {
    // If "GO" is pressed w/o any execute buttons pressed, do all by default:
    if(doOnl==0 && doVtx==0 && doMul==0 && doOut==0 && doSpc==0 && doTof==0) {
      doOnl = 1;
      doVtx = 1;
      doMul = 1;
      //   Temporarily disabled 1/30/99 to avoid crashes with unimplemented
      //doSpc = 1;
      //doTof = 1;
      //doOut = 1; 
    }
    doGo = 1;
  }

  if(phase == 2 && !strcmp(act,"STOP")) doStop = 1;

  //  EXIT button pushed?  Can add other actions before final exit here
  if(phase == 3 && !strcmp(act,"EXIT")) doGo = 10; 

  if(phase == 2 && !strcmp(act,"Pause")) doPause = 1;
  if(phase == 2 && !strcmp(act,"Resume")) doPause = 0;

  //  Called by onlgui.C:
  if(phase == 2 && !strcmp(act,"EXIT")) {
    if(tt) tt->CloseCanvas(); 
    if(onlc2) { onlc2->Close(); onlc2 = NULL; }   // remove the button panels
    if(onlc3) { onlc3->Close(); onlc3 = NULL; } 
    if(barg) { barg->Close(); barg = NULL; } 
    if(view) { view->Close(); view = NULL; }

    //  A problem... we can't call onlc1->Close here; State of Michigan
    //  laws i.e. assisted suicides aren't allowed.  Turn off the display
    //  phase instead & alter Onl.C to use this as a signal.
    flOnl = 0;
  }  
///////////////// Processor buttons: ////////////////////////////////////

  //  doOnl through doOut: Put "EXECUTE" in red letters under the button
  void exflag() {
    TText *texec = new TText(0.1,0.1,"EXECUTE");
    texec->SetTextSize(0.25);
    texec->SetTextColor(2);
    texec->Draw();
    return;
  }

  if(phase == 1 && !strcmp(act,"Onl")) {doOnl = 1; exflag(); ugui("Onl",1);}
  if(phase == 1 && !strcmp(act,"Vtx")) {doVtx = 1; exflag(); ugui("Vtx",1);}
  if(phase == 1 && !strcmp(act,"Mul")) {doMul = 1; exflag(); ugui("Mul",1);}
  if(phase == 1 && !strcmp(act,"Spc")) {doSpc = 1; exflag(); ugui("Spc",1);}
  if(phase == 1 && !strcmp(act,"Tof")) {doTof = 1; exflag(); ugui("Tof",1);}
  if(phase == 1 && !strcmp(act,"Out")) {doOut = 1; exflag(); ugui("Out",1);}

  // The following toggle fl*** between 0 & 1, except split cases.
  // The split buttons (left = display once, right = repeating displays)
  // follow a somewhat complex logic to provide the proper sequences:
  //  flVtx state: | left b. action: | right b. action: | Vtx kDis3 action:
  //--------------------------------------------------------------------------
  //        0      | flVtx 0 -> 1    | flVtx 0 -> 2     | Not called
  //        1      |       1 -> 1    |       1 -> 2     | Display; 1 -> 4
  //        2      |       2 -> 1    |       2 -> 3     | Display; 2 -> 2
  //        3      |       3 -> 3    |       3 -> 3     | Delete;  3 -> 0
  //        4      |       4 -> 3    |       4 -> 2     | no display or change
  //--------------------------------------------------------------------------
    if(phase == 2 && !strcmp(act,"Onl"))  {flOnl = 1 - flOnl; ugui("Onl",2);}
    if(phase == 2 && !strcmp(act,"Vtxr")) {
      Int_t tmpfl = 2;
      if((flVtx == 2) || (flVtx == 3)) tmpfl = 3;
      flVtx = tmpfl;
      ugui("Vtx",2);
    }
    if(phase == 2 && !strcmp(act,"Vtx"))  {
      if(flVtx <= 2) flVtx = 1;
      if(flVtx >= 3) flVtx = 3;      
      ugui("Vtx",2);
    }
    if(phase == 2 && !strcmp(act,"Mulr")) {
      Int_t tmpfl = 2;
      if((flMul == 2) || (flMul == 3)) tmpfl = 3;
      flMul = tmpfl;
      ugui("Mulr",2);
    }
    if(phase == 2 && !strcmp(act,"Mul"))  {
      if(flMul <= 2) flMul = 1;
      if(flMul >= 3) flMul = 3;       
      ugui("Mul",2);
    }
    if(phase == 2 && !strcmp(act,"Spc"))  {flSpc = 1 - flSpc; ugui("Spc",2);}
    if(phase == 2 && !strcmp(act,"Tof"))  {flTof = 1 - flTof; ugui("Tof",2);}

    if(phase == 3 && !strcmp(act,"Onl"))  {flOnl = 1 - flOnl; ugui("Onl",3);}
    if(phase == 3 && !strcmp(act,"Vtx"))  {flVtx = 1 - flVtx; ugui("Vtx",3);}
    if(phase == 3 && !strcmp(act,"Mul"))  {flMul = 1 - flMul; ugui("Mul",3);}
    if(phase == 3 && !strcmp(act,"Spc"))  {flSpc = 1 - flSpc; ugui("Spc",3);}
    if(phase == 3 && !strcmp(act,"Tof"))  {flTof = 1 - flTof; ugui("Tof",3);}

}  // end phatset
