void sensor(Char_t *subdet, Int_t ilayer) {
  //  File sensor.C; macro auxiliary to phatonl.C    D McLeod  08-Jan-1999
  // Set up a button bar for the individual sensors of a layer,
  // for by-sensor information or plots.  Much of below copied from TPhOnSensor
  //   No error checking here, assume caller provides correct args
  Char_t tit[40];
  Char_t mac[80];
  Char_t lab[40];
 
  TPhSubDetector *sub = det->GetSubDetector(subdet);
  TPhLayer *layer = sub->GetLayer(ilayer);
  TObjArray *senslist = layer->GetSensorList();
  Int_t nsensors = senslist->GetEntries();

  // Set up the canvas with the sensor buttons for this layer:
  onlc3 = new TCanvas("sensor","sensor",-165,30,80,790);
  onlc3->SetEditable(0);    // equivalent to DialogCanvas
  onlc3->SetFillColor(38);
  onlc3->SetFillStyle(3014);  // same as phat.C appearance
  onlc3->Draw();

  Float_t xlow = 0.01;
  Float_t xup = .99;
  Float_t ytop = 0.94; // Canvas coord. are 0.0 - 1.0 going up
  Float_t ybot = 0.02;
  Float_t d = (ytop - ybot)/nsensors; // Button spacing
  Float_t s = d/20.0; // half-space between buttons
  Float_t ylow = ytop -d +s;  // initial button bottom
  Float_t yup = ytop -s;      // initial button top

 //  Text right on canvas
  sprintf(lab,"layer %d\nsensors:",ilayer);
  TText *label = new TText(0.05,0.95,lab);
  label->SetTextSize(0.22); 
  label->SetTextColor(5);
  label->Draw();
  
  TIter NextSensor(senslist->MakeIterator());
  TPhSensor *sens;
  while(sens = (TPhSensor*)NextSensor())
  {
     strcpy(tit,sens->GetName());   //method of TNamed
     // Per-sensor plot option during TPhOnSensor layer display
     //if(bbflag == 1) sprintf(mac,"mx(1);tt->Draw(\"%s\");",tit);

     // Per-sensor plot, temporary standin for TPhOnSignal plots
     // which should be put in here when ready
     //    2/13/99:  This becomes the main TPhOnSensorContainer plots
     if(bbflag == 2) 
           sprintf(mac,"mx(1);tt->CloseCanvas();tt->Draw(\"%s\");",tit);
     TButton *but = new TButton(tit,mac,xlow,ylow,xup,yup);
     ylow -= d;
     yup -= d; 
     but->SetFillColor(4);
     but->SetTextColor(10);
     but->SetTextSize(0.28);
     but->Draw();
  }  
}
