{

// this macro shows how to use the TPhPIDSpect class
// at initialization the PID bands parameters are read(from TPhPIDSpect.dat)
// it sets PMC data: 10ev.aou.root - HIJET central 10ev.
// made by A.T. 29 April 1998             

gROOT.Reset();
gROOT.Time();

TCanvas *c1 = new TCanvas("c1", "PID test",344,74,800,700);
c1->SetHighLightColor(2);
c1->SetFillColor(0);
c1->SetBorderMode(0);
c1->SetBottomMargin(0.2);
TH1F hp_ib_pi("hp_ib_pi","momentum ib", 50,0.0,2.);
TH1F hp_ig_pi("hp_ig_pi","momentum ig", 50,0.0,2.);

TPhEvent   *event;
TPhMCTrack *track;
TObjArray  *TrackList;

TPhObjectContainer *tracks;
TObjArray          *CList;
TPhObjectContainer *DContainer;

// reads the PID bands parameters
PID = new TPhPIDSpect("../../init/TPhPIDSpect.dat2");

TPhASCIIData *dst = new TPhASCIIData("1ev.aou");
if( !dst ) {
  fprintf(stderr,"AouToRoot: problems creating TPhASCIIData object - exiting.");
  exit(0);
}
TPhDetector *det = TPhDetector::GetInstance();

/*
Char_t FileName[100];
sprintf(FileName,"1ev.aou.root",""); 
TPhDST *dst = new TPhDST(FileName);

TPhDetector *det = TPhDetector::ReadLatestGeometry();
*/

Float_t p;
Float_t PROB[3];
Int_t ig,ib;

Int_t i = 0;

while( event = dst->GetNextEvent() ) 
{
  i++;
  if(i%10==0)printf(" event no %d \n",i);
  tracks =      (TPhObjectContainer*) event->GetObject("MCTracks");
  if(tracks ) CList = tracks->GetObjectList();
  if( CList ) 
    {
      TIter TrackIter(CList);
      while( track = (TPhMCTrack*) TrackIter()) 
	{

	  // a track is selected - has to have 13 hits in one oarm
	  Int_t iarm = PID->Arm(track);

	  if(iarm)
	    {
	      // true genat id
	      ig=track->GetGPid();

       	      p =track->GetP();

	      // ib =1,2,3,0 when the track falls into pi,K,p band or outside 
	      ib = PID->GetBand( track);

              // PROB[0], PROB[1], PROB[2] - the probability that track is pi,K or p 
	      PID->GetProb(track,PROB);

              // an example of a cut 
	      if( p>0.09 && ( ig ==  8 || ig ==  9 ) ){
		hp_ig_pi->Fill(p);
		if( ib==1 && PROB[0] > 0.98 )hp_ib_pi->Fill(p);}
	    }
	}
    }
  delete event;  
}
delete dst;

// drawing stuff

hp_ib_pi.Draw();
hp_ig_pi.Draw("same");
hp_ib_pi->SetFillColor(6);

gStyle->SetTitleX(10.);
gStyle->SetTitleY(10.);

text = new TText(1.5,-0.1*hp_ig_pi.GetMaximum(),"p(GeV/c)");
text->SetTextSize(0.07);
text->Draw();
text = new TText(1.,0.5*hp_ig_pi.GetMaximum(),"identified pions");
text->SetTextSize(0.05);
text->SetTextColor(6);
text->Draw();
text->SetTextSize(0.07);
text->Draw();

}
