      SUBROUTINE ADDPMCHIT(ITRACK, DNAME, IPLHIT, X, Y, Z, DE, DT,
     +                                       DX, DY, DZ, IX, IY, TLNG)
*Documentation_Block
************************************************************************
*
*  Description:
*  Interface to PHAT memory (dummy version to be linked with standalone PMC)
*
*  Arguments:
*  ITRACK   - track number (for a double check)
*  DNAME    - name of the detector hit
*  IPLHIT   - number of the plane hit
*  X, Y, Z  - position of the center of the hit
*            (point in the middle between entrance and exit)
*  DE       - energy lost by the particle in the detector
*  DT       - time at which particle entered the detector
*  DX,DY,DZ - vector between the entrance and exit
*  IX, IY   - pixel (pad, strip) number in the detector (not 0 only if
*             pixelization is switched on)
*  TLNG     - length of the track up to the hit
*
*  Called by:
*  PH_OUT
*
*  Calls:
*
*  Implicit inputs, outputs, side effects:
*  none
*
*  History:
*  Date       Name       Description
*  ----       ----       -----------
*   14-Jul-98  K.W.    add track length to the parameter list
*   10-Feb-98  K.W.    Creation
************************************************************************
*End_Documentation_Block

      IMPLICIT NONE

      CHARACTER*4 DNAME
      INTEGER  ITRACK,  IPLHIT, IX, IY
      REAL  X, Y, Z, DE, DT, DX, DY, DZ, TLNG

C
C     Executable Statements
C     =====================
C

cccc      WRITE(99,  '(1X, I4, 3F11.4, F10.6, E15.7, 3F9.4,
cccc     +              2I4, F11.4)' )
cccc     +  IPLHIT, X, Y, Z, DE, DT, DX, DY, DZ, IX, IY, TLNG

      RETURN
      END
