      SUBROUTINE ADDPMCTRACK(CVOL, ITRACK, IPARENT, NHITS, ID,
     +                          PX, PY, PZ,  VX, VY, VZ, ISTOP)
     +
*Documentation_Block
************************************************************************
*
*  Description:
*  Interface to PHAT memory (dummy version to be linked with standalone PMC)*   FOR TESTS ONLY
*
*  Arguments:
*   CVOL      - name of the origin volume (ORIG in case of primaries)
*   ITRACK    - track number
*   IPARENT   - parent number (0 in case of primaries, <0 if parent not stored)
*   NHITS     - number of hits
*   ID        - particle type (GEANT id)
*   PX,PY,PZ  - particle momentum at creation
*   VX,VY,VZ  - point at which particle was created
*   ISTOP     - Geant ISTOP flag
*
*  Called by:
*  PH_OUT
*
*  Calls:
*
*  Implicit inputs, outputs, side effects:
*  none
*
*  History:
*  Date       Name       Description
*  ----       ----       -----------
*   13-Nov-98  K.W.    Added ISTOP
*   10-Feb-98  K.W.    Creation
************************************************************************
*End_Documentation_Block

      IMPLICIT NONE

      CHARACTER*4 CVOL
      INTEGER  ITRACK, IPARENT, NHITS, ID, ISTOP
      REAL  PX, PY, PZ,  VX, VY, VZ
C
C     Executable Statements
C     =====================
C
cccc      WRITE(99,
cccc     +  '('' P '', A4, I8, I9, I4, I3, 3F12.6, 3F10.3, I2)' )
cccc     +  CVOL, ITRACK, IPARENT, NHITS, ID,
cccc     +  PX, PY, PZ,  VX, VY, VZ, ISTOP

      RETURN
      END
