      SUBROUTINE GET_KINE(ID, PLAB, VERT)
*Documentation_Block
************************************************************************
*
*  Description:
*  Get from user or PHAT the data on particle tyo be simulated
*
*  Arguments:
*  ID      - particle GEANT id
*  PLAB    - momentum of the particle (px,py,pz) (in GeV)
*  VERT    - point of origin of the particle (vx,vy,vz)
*
*  Called by:
*  GUKINE
*
*  Calls:
*
*  Implicit inputs, outputs, side effects:
*  Reads information from standard input - or from a common /CGETKINE/
*
*  History:
*  Date       Name       Description
*  ----       ----       -----------
*   11-Feb-98  K.W.    Creation
************************************************************************
*End_Documentation_Block

      IMPLICIT NONE

      INTEGER  ID, I
      REAL PLAB(3), VERT(3), PTOT,  THETA, PHI

*KEEP,CGETKINE.
c CGETKINE.CMN: Common to interface GET_KINE with PUT_V_KINE and PUT_A_KINE
c  11-Feb-98  K. W.     Creation

      INTEGER ISTOIND, IDSTO
      REAL PLABSTO(3), VERTSTO(3)
      COMMON /CGETKINE/ ISTOIND, IDSTO, PLABSTO, VERTSTO
*KEEP,GCFLAG.
      COMMON/GCFLAG/IDEBUG,IDEMIN,IDEMAX,ITEST,IDRUN,IDEVT,IEORUN
     +        ,IEOTRI,IEVENT,ISWIT(10),IFINIT(20),NEVENT,NRNDM(2)
      COMMON/GCFLAX/BATCH, NOLOG
      LOGICAL BATCH, NOLOG
C
      INTEGER       IDEBUG,IDEMIN,IDEMAX,ITEST,IDRUN,IDEVT,IEORUN
     +        ,IEOTRI,IEVENT,ISWIT,IFINIT,NEVENT,NRNDM
C
*KEND.
C
C     Executable Statements
C     =====================
C

      ID = 0
      IF(BATCH  .AND.  ISTOIND .LT. 0)  THEN
         WRITE(*,*) ' ***** GET_KINE: NO INPUT PARTICLE IN GEN=10',
     +               ' MODE - IN PHATPMC OR IN PMC BATCH MODE'
         RETURN                  !  >>>  in standalone PMC - batch mode
      ENDIF                      !       or in Phat (also "batch" mode)

      IF(ISTOIND .GT. 0)  THEN   !  get the information from the common
         DO  I=1,3
            PLAB(I) = PLABSTO(I)
            VERT(I) = VERTSTO(I)
         ENDDO
         ID = IDSTO
         ISTOIND = 0    !    information already used
         RETURN         !    >>>>>
      ENDIF

      WRITE(*,*)  ' +++++ REQUEST FROM GUKINE:'
      WRITE(*,*)  ' GIVE PARTICLE  ID:'
      READ *, ID
   10 CONTINUE
      WRITE(*,*)  ' SELECT MOMENTUM FORMAT: ',
     +               '(P IN GEV, THETA,PHI IN DEGREES)'
      WRITE(*,*)  ' 0 =  PX,PY,PZ '
      WRITE(*,*)  ' 1 =  PTOT,THETA,PHI'
      READ *, I
      IF(I .EQ. 0)  THEN
         WRITE(*,*) ' PX, PY, PZ:'
         READ *, PLAB(1), PLAB(2), PLAB(3)
      ELSE IF(I .EQ. 1)  THEN
         WRITE(*,*) ' PTOT,THETA,PHI:'
         READ *, PTOT, THETA, PHI
         PLAB(1) = PTOT * SIN(THETA/57.2957795) * COS(PHI/57.2957795)
         PLAB(2) = PTOT * SIN(THETA/57.2957795) * SIN(PHI/57.2957795)
         PLAB(3) = PTOT * COS(THETA/57.2957795)
      ELSE
         GO TO 10
      ENDIF

      RETURN
      END
