      SUBROUTINE PH_INIT
*Documentation_Block
************************************************************************
*
* Description:
*  Subroutine PH_INIT books histograms and nutples for the Phobos MC.
*
* Arguments: none
*
* Called by:
*  USINIT
*
* Calls:
*  DATE, HBOOK1, HBOOK2, HBOOKN, HRFILE, TIME
*
* Implicit inputs, outputs, side effects:
*  Allocates Zebra storage banks; uses HBOOK id's 1 and 2
*
* Filename: PMC_SRC:PH_INIT.FOR
*
* History:
* Date      Name       Description
* ----      ----       -----------
* 13-Feb-98  K. W.     Report level controlled by  SWIT(7)
*                        SWIT(7) = 1  - opening of ntuple files reported
*                        SWIT(7) = 0  - only errors reported
* 04-Aug-97  R. V.     Give translated filename to HROPEN if available (RV)
* 21-Jul-96  R. V.     Removed unused xmx, nz, xmin
* 08-Sep 95 DMcL       DATE, TIME => Cernlib DATIMH & associated changes
* 23-Jun-95 D. McLeod  UFILE replaced by SERVER as part of UNIX port
*  1-Nov-93  R.V.      BANG.CMN -> BANGC.CMN to avoid MMS confusion
* 17-Jun-93 R. V.      Move ntuple parameters to common NTUEX
* 22-Feb-93 R. V.      Correct directory handling via HCDIR
* 10-Jan-93 R. V.      Separate ntuples for hits and mc
* 03-Aug-92 R. Verdier Set IQUEST(10) for larger Ntuple file (PAW p. 32)
*    Apr-92 C. Parsons Separated from GPH
*    Mar-92 D. Mcleod  Creation as UHINIT in GPH.FOR
************************************************************************
*End_Documentation_Block

      IMPLICIT NONE

*KEEP,IO.
C Common block for GPH logical units etc.: file IO.CMN
c 13-Aug-96  R. V.       Added USRBATCHK for KUIP commands for UGCONS
c 21-Jul-96  R. V.       Remove unused record; note CARDDEF now obsolete
c 22-Feb-93  R. V.       Added USRMCNTU and IMCNTU for MC Ntuple
c 14-Nov-92  R. Verdier  Added UGCIN, IUGCIN, CARDDEF and ICARDDEF
c                        for UGC and EUCARD (obsolete) input units
C    Apr-92  C. Parsons  Replacement for original COMMON.CDT
      INTEGER USRGCIN, CARDDEF, USRIN, USROUT, USRMAP, USRNTU, USRZEB,
     *  USRMCNTU, USRBATKUMAC
      PARAMETER (USRIN = 4, USROUT = 16, USRMAP = 18)
      PARAMETER (USRNTU = 15, USRZEB = 17, USRGCIN = 19, CARDDEF = 20)
      PARAMETER (USRMCNTU = 21, USRBATKUMAC = 22)
      INTEGER ICARDDEF, IMCNTU, IUSRGCIN, IUSRIN, IUSROUT, IUSRMAP,
     *  IUSRNTU, IUSRZEB, IUSRAOU, IUSRBATKUMAC
      COMMON /IO/ IUSRIN, IUSROUT, IUSRMAP, IUSRNTU, IUSRZEB, IUSRGCIN,
     *  ICARDDEF, IMCNTU, IUSRAOU, IUSRBATKUMAC
*KEEP,GCFLAG.
      COMMON/GCFLAG/IDEBUG,IDEMIN,IDEMAX,ITEST,IDRUN,IDEVT,IEORUN
     +        ,IEOTRI,IEVENT,ISWIT(10),IFINIT(20),NEVENT,NRNDM(2)
      COMMON/GCFLAX/BATCH, NOLOG
      LOGICAL BATCH, NOLOG
C
      INTEGER       IDEBUG,IDEMIN,IDEMAX,ITEST,IDRUN,IDEVT,IEORUN
     +        ,IEOTRI,IEVENT,ISWIT,IFINIT,NEVENT,NRNDM
C
*KEEP,NTU.
C Common block for Ntuple image and other analysis info.  File NTU.INC
C There may be one Truth Ntuple and/or one Hits Ntuple for each track.
C These must be correlated into events using the event number and other
C event information.
C 10-Jul-95  K. W.      Increased number of planes for spectrometer to 17
C 10-Mar-95  K. W.      Increased number of planes for spectrometer
C 19-Jul-94  R. V.      Update tagnames: Cxx -> Dxx, VOLTERM -> VOLUME
C 10-May-94  R. V.      Modify Ntuples to contain new hits information;
C                       add NTTAGS common for tags; move data to NTUD.INC
C 29-Jun-93  M. Baker   Modify Ntuples
C 10-Jan-93  R.Verdier  Separate Hits and Truth ntuples; rename to NTU.CMN
C    Mar-92  D. Mcleod  Creation as COMMON.NTU
C Number:  Name:    --------------- Description:----------------------------
C>>>>>>>GENERAL INFORMATION<<<<<<<<<<<<<<<<<<
*   1      RUN      run number
*   2      EVENT    event number
*   3      TRACK    track number
*   4      GEN      event generator type; 1 = fixed, 2 = random, etc.
*   5      ANAL     event analysis type; 1 = Ntuple only, 2 = resolution, etc.
*   6      SCAT     ISCAT = IMULS + 3*ILOSS + 9*IPIXL; 1st 2 are in /GCPHYS/
*   7      BIMP     Impact Parameter   ** NOT YET IMPLEMENTED **
C>>>>>>>THE TRUTH<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*   8      XPROD    track origin
*   9      YPROD       "    "
*   10     ZPROD       "    "
*   11     IDPART   particle type (GEANT code)
*   12     CHRG     particle charge
*   13     TP       particle momentum (at production)
*   14     TK          "     kinetic energy    "
*   15     TPHI        "     azimuth angle
*   16     TTHETA      "     polar angle
C>>>>>>>ANALYSIS RESULTS..FOR THE WHOLE TRACK<<<<<<<<<<<<<<<<<<
*   17     ACCEPT   Acceptance Flag (+/-1=acc. in +/- wing, 2=both, 0=neither)
*   18     NHITSL   number of hits on track, set to a maximum of NHTM
*   19     USR1     spare, for later use
*   20     USR2              "
C>>>>>>>TRACK HITS<<<<<<<<
* The Truth ntuple stops here; the Hits ntuple continues with
* A series of particle history words
* NHITSL groups of 12 words each, at index = 32 + 12*(Ihit-1):
*
*   21     KCASE    creation mechanism
*   22     PARENT   track number
*   23     VOLUME   creation volume name
*   24     XTERM
*   25     YTERM
*   26     ZTERM
*   27     PXTERM
*   28     PYTERM
*   29     PZTERM
*   30     ETERM
*   31     STOP     stop mechanism

*   32+    PL       plane number hit
*   33+    X        Track center in plane in master coords (maybe pixeled)
*   34+    Y          "     "     "   "    "  "      "       "       "
*   35+    Z          "     "     "   "    "  "      "       "       "
*   36+    DE       Energy deposited in the plane
*   37+    DX       Exit minus entry position in master coord system
*   38+    DY        "    "    "    "      "        "    "
*   39+    DZ        "    "    "    "      "        "    "
*   40+    EFIN     track energy at exit from plane
*   41+    TOF      time registered by a TOF detector, in seconds
*   42+    ITRK     track number for this hit
*   43+    IS       Combined information:  IS = IVOL + 1000 * ISEQ
*                   ISEQ = sequential (first = 1) hit number on this track
*                   IVOL = system volume number of the plane
C The maximal number of hits is now NHTM = 17
C There are thus 31 + 12*NHTM or 235 entries in a Hits Ntuple, with zeroes
C after the last hit

      INTEGER NVMCTUP,NVTUP,NTOFF,NHTM
      PARAMETER (NTOFF=31, NVMCTUP=20, NHTM=17)
      PARAMETER (NVTUP=31+12*NHTM)

      REAL    RUN, EVENT, TRACK, GEN, ANAL, SCAT, BIMP
      REAL    XPROD, YPROD, ZPROD, IDPART, CHRG, TP, TK, TPHI, TTHETA
      REAL    ACCEPT, NHITSL, USR1, USR2
      REAL    STOP, PARENT, VOLTERM, XTERM, YTERM, ZTERM, PXTERM, PYTERM
      REAL    PZTERM, ETERM, UNUSED
      REAL    TRK(12,NHTM), TUP(NVTUP)

      COMMON/RHTUP/ RUN, EVENT, TRACK, GEN, ANAL, SCAT, BIMP,
     1  XPROD, YPROD, ZPROD, IDPART, CHRG, TP, TK, TPHI, TTHETA,
     2  ACCEPT, NHITSL, USR1, USR2, STOP, PARENT, VOLTERM, XTERM,
     3  YTERM, ZTERM, PXTERM, PYTERM, PZTERM, ETERM, UNUSED,
     4  TRK

      EQUIVALENCE (TUP(1),RUN)

      COMMON /NTTAGS/ TAGS(NVTUP)
      CHARACTER*8 TAGS
*KEEP,NTUEX.
c NTUEX.INC: PHOBOS MC Ntuple option extensions
c 10-May-94 R. V.     Correct filenames in documentation
c 6-Jun-93 R. V.     Creation
c This include file defines options for the size and format of the
c Phobos ntuples.  Data values are assigned in NTUEXD.INC.
c Define sizes for allocating ntuples, in 4-byte words.  The NHtrks
c and NMCtrks values limit the total size of the created disk file.
c The default values assigned to NWHits and NWMC here are actually
c overridden by Nvtup and Nvmctup, respectively, in NTUD.INC.
      common /NTUEX/ LreclW, NWHits, NWMC, NWover, NWPRIM,
     1               NHtrks, NMCtrks
      integer
     1  LreclW,  ! Disk file logical record length, words
     2  NWHits,  ! # Hits ntuple variables [columns]
     3  NWMC,    ! # MC Truth ntuple variables [columns]
     4  NWover,  ! Approx. Zebra system overhead, words
     5  NWprim,  ! Primary storage buffer, words
     6  NHtrks,  ! Maximum # of tracks in Hits ntuple
     7  NMCtrks  ! Maximum # of tracks in MC ntuple
*KEEP,FLAG.
C  PHOBOS flags, run control, operating modes, misc.   File FLAG.CMN
C   7-Jul-98  K. W.      Added  ITRIG flag (initial numer in TRIG command)
C  27-Nov-97  K. W.      Added IAOUF flag
C  31-Mar-95  R.V.       Change STRA to SECT to avoid GEANT 3.21 conflict
C  22-Nov-92  D. McLeod
C   These are set in input cards
      INTEGER ISASC,ISHBO,ISHDO,ISNTU, ISMEM,ISAOU,IAOUF, ISECT,IDRAW,
     1        IGEN,IANAL,ISCAT,IPIXL,ISEQ,NTRK,IZEB, ITRIG
      REAL WPIXL,WLOSS
      COMMON/RHFLG/ISASC,ISHBO,ISHDO,ISNTU,
     1  ISMEM,ISAOU,IAOUF, ISECT,IDRAW,
     2  IGEN,IANAL,ISCAT,IPIXL,ISEQ,NTRK,IZEB,WPIXL,WLOSS, ITRIG
*KEEP,HST.
C  File HST.CMN (originally COMMON.HST)
C  Common block for inline plot control.. to generate plots during
C  the GEANT run from the track Ntuples (rather than later via PAW)
C  Its contents are set by control cards in the same file as FFREAD:

C  HIST ID TAGNAME  (short form.. default bins and interval)
C    TAGNAME can be Ntuple tag name or e.g. #35 for 35th entry

C  HIST ID TAGNAME NCHANNELS XMIN XMAX is the long form.
C  HIST ID TAGX NX XMI XMA TAGY NY YMI YMA  scatterplot, args as HBOOK2
C  (The number of arguments distinguishes these three formats.)

C      HCONTROL(I,J), J = 1,NHMX contains the control information:
C  I = 1:  User supplied ID number of plot, floated integer
C  I = 2:  Ntuple entry number (floated), from TAGNAME or # input
C  I = 3:  number of channels (0 if short form card)
C  I = 4-5 or 4-9: arguments as in card formats above, all floating

      INTEGER NHMX,NHSTS
      PARAMETER(NHMX=50)
      REAL HCONTROL
      COMMON/RHHST/HCONTROL(9,NHMX),NHSTS

*KEEP,RHSYS.
C  Common blocks for GPH PHOBOS simulation:  FILE RHSYS.CMN
C  General geometric layout of PHOBOS detector exclusive of detectors
C  These values are on input cards or data statements, except *MAX are
C  calculated to encompass all elements of the system.
C  20-Sep-96  K.W       Removed obsolete BMTBRAD, BERTHIK
C                       Removed FANGL - now local variable in BANG
C  12-Jul-96  K.W       Position of the magnet pole center MAGX, MAGZ
C                       (previously XOFF,ZOFF) separated from the magnet
C                       offset (now MOFF - 3-D vector)
C  14 Dec-92  R.V.      TMAG redefined and changed to integer
C  22-Nov-92 D. McLeod  Renamed from COMMON.SYS; TMAG, ZOFF, XOFF
C                       are added from the original GPH version
      REAL   BFLD         ! Magnetic field strength
     &      ,MAGX,MAGZ    ! Coordinates of field center
     &      ,MOFF(3)      ! offset of the field
     &      ,RFLD         ! Radius of field (perfect dipole only)
     1   ,XMAX,YMAX,ZMAX,ZMIN,XMMAX,ZMMAX
      INTEGER MAGT, TMAG  ! Field type: 0 Zebra bank, 1 = dipole,
                          ! 2 = ASCII map
      COMMON/RHSYS/ BFLD,MAGT,MAGX,MAGZ,MOFF
     1  ,RFLD,XMAX,YMAX,ZMAX,ZMIN,XMMAX,ZMMAX
      EQUIVALENCE (TMAG, MAGT)
*KEEP,BANGC.
C Event generator parameters                 File: BANGC.CMN
C 20-Sep-96  K. Wozniak Added new parameters to control BANG mode = 2
C                       RSPX, RSPZ, RSPR (removed RMAG)
C 10-Mar-95  K. Wozniak Added new parameters to control track generation
c                       and selection (ETAMIN,ETAMAX, IDMIN,IDMAX ..)
c 22-Jun-94  R. V.      Remove NSEQN storage (see PH_HIT)
c 10-May-94  D. McLeod  Increased MXMUL to 13000 for HIJET events
c 17-Dec-92  R. Verdier Changed name from BANG to BANGC for CMS
c 22-Nov-92  D. Mcleod  Added EXF and NSEQN
      INTEGER MXMUL
      PARAMETER (MXMUL=13000)  ! maximum multiplicity for BANG etc.
      INTEGER IRMUL         !  multiplicity in random particle generation
      INTEGER IRARM         !  particles going to 1 or 2 arms selected
      INTEGER IRPID(2)      !  particle id range: min, max
      REAL RMOM(3)          !  momentum of particles:  min, max and step
                            !  (first step if 1/p is changed)
      REAL REXP             !  mean transv. mom. - for momentum generation
      REAL RETA(2)          !  ETA range: min, max
      REAL RANG(3)          !  starting theta angle and step
      REAL RPHI(2)          !  range of emission phi angle: min, max
      REAL RROT(2)          !  phi initial and additional rotation angle (GEN=0)
      REAL RBXX,RBYY,RBZZ   !  central position of the vertex
      REAL RBXY             !  width of the beam intersection in x-y
      REAL RBDX,RBDY,RBDZ   !  the range of positions of the vertex
C                           !
      REAL RSPX,RSPZ,RSPR   !  position and radius of the circle describing
C                           !  area covered by spectrometer
      REAL PHIR,CZ,ZC,RS    !  working variables for BANG
      COMMON/RHBNG/IRMUL, IRARM, IRPID, RMOM, REXP, RETA, RANG, RPHI,
     1             RROT,
     2             RBXX,RBYY,RBZZ, RBDX, RBDY, RBDZ, RBXY,
     3             RSPX,RSPZ,RSPR, PHIR,CZ,ZC,RS
*KEND.
c temporary for IQUEST(10)
      COMMON /QUEST/ IQUEST(100)
      INTEGER IQUEST

C     Local definitions:
C     ==================
C
      CHARACTER*60 TITLE
      INTEGER NDH(2), NTH(2)
      CHARACTER*8 TAGX,TAGY
C
C
      INTEGER ID,NX,NY,I,IOS,J
      character*60 FileName

c End of declarations

      CALL DATIMH (NDH, NTH)
      WRITE(TITLE,1000) (NDH(I),I=1,2),(NTH(I),I=1,2),IDRUN

**************************************************************
*  SET UP HITS NTUPLE IF ISNTU CONTAINS 1, TRUTH NTUPLE IF IT
*  CONTAINS 2
**************************************************************

      IF (IAND(ISNTU,1) .ne. 0) THEN
        call UFILE (1, 'RHNTU', Iusrntu, FileName)
        if (Iusrntu .gt. 0) then
          call HCDIR ('//PAWC',' ')
          call HMDIR ('RHTUP','S')
          NWHits = NVTUP
          Iquest(10) = (NHtrks * NWHits + NWover) / LreclW
          call HROPEN (Iusrntu, 'RHTUPF', FileName, 'NQ', LreclW, IOS)
c Set directory to the ntuple in memory; HROPEN leaves the disk file
c directory set to RHTUPF.
          call HCDIR ('//PAWC/RHTUP',' ')
          call HBOOKN (1, TITLE, NWHits, '//RHTUPF', NWprim, Tags)
          call HCDIR ('//PAWC',' ')
          if (ISWIT(7) .ge. 1)
     1      write (*,'(3a,i5,a,i6,a)') ' Hits ntuple file ', FileName,
     2        ' opened,',
     3        Iquest(10), ' records for', NHtrks, ' tracks.'
        else   !   (Iusrntu .eq. 0)
          if (ISWIT(7) .ge. 0)
     1      write (*,*) ' Hits ntuple file open failed.'
        endif   !   (Iusrntu .gt. 0)
      ENDIF   !  (IAND(ISNTU,1) .ne. 0)

      if (iand(ISNTU,2) .ne. 0) then
        call UFILE (1, 'MCNTU', Imcntu, FileName)
        if (Imcntu .gt. 0) then
          call HCDIR ('//PAWC',' ')
          call HMDIR ('MCTUP','S')
          NWMC = Nvmctup
          Iquest(10) = (NMCtrks * NWMC + NWover) / LreclW
          call HROPEN (Imcntu, 'MCTUPF', FileName, 'NQ', LreclW, IOS)
          call HCDIR ('//PAWC/MCTUP',' ')
          call HBOOKN (2, Title, NWMC, '//MCTUPF', NWprim, Tags)
          call HCDIR ('//PAWC',' ')
          if (ISWIT(7) .ge. 1)
     1      write (*,'(3a,i5,a,i6,a)') ' MC ntuple file ', FileName,
     2        ' opened,',
     3        Iquest(10), ' records for', NMCtrks, ' tracks.'
        else   !   (Imcntu .eq. 0)
          if (ISWIT(7) .ge. 0)
     1      write (*,*) ' PH_INIT failed to open MC Ntuple file, ',
     2        'logical "MCNTU"'
        endif   !   (Imcntu .gt. 0)
      endif   !   (iand(ISNTU,2) .ne. 0)

******************************************
* BOOK HISTOGRAMS SET BY CONTROL CARDS   *
******************************************
      IF(NHSTS.GT.0) THEN
         DO I = 1,NHSTS
            TAGX = TAGS(NINT(HCONTROL(2,I)))

            IF(TAGX.EQ.' ') THEN
               WRITE(TAGX,1300) HCONTROL(2,I)
            ENDIF

            ID = NINT(HCONTROL(1,I))
            NX = NINT(HCONTROL(3,I))

            IF(NINT(HCONTROL(6,I)).EQ.0) THEN
               WRITE(TITLE,1100)IDRUN,
     1                   (NDH(J),J=1,2),(NTH(J),J=1,2),TAGX
               CALL HBOOK1(ID,TITLE,NX,HCONTROL(4,I),
     1                     HCONTROL(5,I),0.0)
            ELSE
               TAGY = TAGS(NINT(HCONTROL(6,I)))
               IF(TAGY.EQ.' ') THEN
                  WRITE(TAGY,1300) HCONTROL(6,I)
               ENDIF
               NY = NINT(HCONTROL(7,I))
               WRITE(TITLE,1200)IDRUN,
     1                   (NDH(J),J=1,2),(NTH(J),J=1,2),TAGY,TAGX
               CALL HBOOK2(ID,TITLE,NX,HCONTROL(4,I),HCONTROL(5,I),
     1              NY,HCONTROL(8,I),HCONTROL(9,I),0.0)
            ENDIF   !   (NINT(HCONTROL(6,I)).EQ.0)

         ENDDO   !   DO I = 1,NHSTS

      ENDIF   !   (NHSTS.GT.0)

      RETURN

1000  FORMAT(' Ntuple, on ',2A4,', ',2A4,', Run ',I3)
1100  FORMAT(' Run ',I3,' on ',2A4,', ',2A4,' Tag= ',A8)
1200  FORMAT(' Run ',I3,' on ',2A4,', ',2A4,', ',A8,' vs. ',A8)
1300  FORMAT('Tag',F5.0)
      END
