C     =====================================================================
C     File: PMC_SRC:PHCOMIS.FOR
      Subroutine PHCOMIS
C
C     Description:  Define PHOBOS specific common blocks and routines
C     ============  to COMIS, so they can be CALLed in GEPHOB
C
C
C
C     Arguments:  None
C     ==========
C
C     Conditions returned: None
C     ====================
C
C     Implicit inputs, outputs, side effects:
C     =======================================
C
C       Called by: UGINIT
C       Calls:   CSEXT CSCOM
C
C       Impicit inputs   None
C
C       Implicit outputs  Comis function database is updated
C
C
C     Author: C. Parsons
C     =======
C
C     Creation Date:  29-Jun-1992
C     ==========================
C
C     Revisions:
C     ==========
C       Date     Name    Description
C       -------  ----    -------------------------------------------------
*   1-Nov-93  R.V.       BANG.CMN -> BANGC.CMN to avoid MMS confusion
C
C
C     Global specifictions:
C     =====================
      implicit none
C
C     External specifications:
C     ========================
      EXTERNAL SETBATCH
C
C Common blocks to be declared. We don't care about real contents
C just need a pointer to first word of block
C
C+SEQ, FLAG.
      COMMON /FLAG/ IRHFLG
      Integer IRHFLG

C+SEQ, BANGC.
      COMMON /RHBNG/ IRHBNG
      Integer IRHBNG

C+SEQ, RHSIL.
      COMMON /RHSIL/ IRHSIL
      Integer IRHSIL

C+SEQ, RHSYS.
      COMMON /RHSYS/ IRHSYS
      Integer IRHSYS

C+SEQ, IO.
      COMMON /IO/ IIO
      Integer IIO
C
C     Local definitions:
C     ==================
      integer dmy
C
C     Executable Statements
C     =====================
C
C  STRINGS MUST BE UPPER CASE!!!
C
C PHobos Specific routines Up to ten per call
C
C First argument is UPPER case string comma deliminted to listing the names
C of the routines. String is ended with a #. Following ten arguments are
C the associated routines to call. Only first 8 characters are significant.
C Be sure and declare the routines to be external.
C
      CALL CSEXT('SETBATCH#',SETBATCH,dmy
     &    ,dmy,dmy,dmy,dmy,dmy,dmy,dmy,dmy,dmy)
C
C
C  Phobos common blocks  similar syntax but give first variable in common
C  block
C
      Call CSCOM('RHFLG,RHBNG,RHSIL,RHSYS,IO#',
     &            IRHFLG,IRHBNG,IRHSIL,IRHSYS,IIO,dmy
     &            ,dmy,dmy,dmy,dmy,dmy)
      Call USCOMIS
      END
