      SUBROUTINE PRNTUP(LU,TAGS,INVAL,N,HEAD)

*Documentation_Block
************************************************************************
*
*  Description:
*  Print out an Ntuple (or similar) and its tags in 4 columns
*
*  Arguments:
*  *LU    Logical unit for output                                (input)
*  *TAGS  Ntuple tag fieldnames                                  (input)
*  *INVAL Values from the ntuple                                 (input)
*  *N     # of columns in the ntuple                             (input)
*  *HEAD  Output header line                                     (input)
*
*  Called by:
*  PH_OUT
*
*  Calls:
*  none
*
*  Implicit inputs, outputs, side effects:
*  none
*
*  History:
*  Date       Name       Description
*  ----       ----       -----------
*  05-Apr-96  D. Mcleod  Remove extra parentheses in write(lu,201
*  19-Nov-92  R. Verdier Separated from package
*     Apr-92  D. Mcleod  Creation in GPH package
************************************************************************
*End_Documentation_Block

      IMPLICIT NONE

      INTEGER N, LU, I, J, K, KK
      CHARACTER*8 TAGS(N)
      CHARACTER*(*) HEAD
      REAL INVAL(N)

C  User specified header line; then output in columns
      WRITE(LU,100) HEAD
      K = (N + 3)/4
      KK = 3*K
      WRITE(LU,101) ((J-1)*K,J=1,4)

      DO I = 1,K
         IF((KK+I).GT.N) THEN
            WRITE(LU,201)I,(TAGS(J),INVAL(J),J=I,KK+I-K,K)
         ELSE
            WRITE(LU,200)I,(TAGS(J),INVAL(J),J=I,KK+I,K)
         ENDIF
      ENDDO

      RETURN

  100 FORMAT(1X,A)
  101 FORMAT(' #  ',4('|TAGS',2X,I3,2X,'VALUE',2X))
  200 FORMAT(1X,I2,1X,4('|',A8,G10.3))
  201 FORMAT(1X,I2,1X,3('|',A8,G10.3))

      END
