      SUBROUTINE PUTAKINE(ID, PTOT, THETA, PHI, VX, VY, VZ)
*Documentation_Block
************************************************************************
*
*  Description:
*  Store in common CGETKINE the information for GET_KINE
*
*  Arguments:
*  ID        - particle GEANT id
*  PTOT      - total momentum of the particle (GeV)
*  THETA,PHI - emission angles (in degrees)
*  VX,VY,VZ  - point of origin of the particle
*
*  Called by:
*  PHAT program
*
*  Calls:
*
*  Implicit inputs, outputs, side effects:
*  Puts information to a common /CGETKINE/
*
*  History:
*  Date       Name       Description
*  ----       ----       -----------
*   11-Feb-98  K.W.    Creation
************************************************************************
*End_Documentation_Block

      IMPLICIT NONE

      INTEGER  ID
      REAL VX, VY, VZ
      REAL PTOT,  THETA, PHI

*KEEP,CGETKINE.
c CGETKINE.CMN: Common to interface GET_KINE with PUT_V_KINE and PUT_A_KINE
c  11-Feb-98  K. W.     Creation

      INTEGER ISTOIND, IDSTO
      REAL PLABSTO(3), VERTSTO(3)
      COMMON /CGETKINE/ ISTOIND, IDSTO, PLABSTO, VERTSTO
*KEND.
C
C     Executable Statements
C     =====================
C


         VERTSTO(1)  = VX
         VERTSTO(2)  = VY
         VERTSTO(3)  = VZ

         IDSTO = ID
         ISTOIND = 1    !    new information saved

         PLABSTO(1) = PTOT * SIN(THETA/57.2957795) * COS(PHI/57.2957795)
         PLABSTO(2) = PTOT * SIN(THETA/57.2957795) * SIN(PHI/57.2957795)
         PLABSTO(3) = PTOT * COS(THETA/57.2957795)

      RETURN
      END
