*Deck STOPER             ! SHELL routines

      SUBROUTINE STOPER (FROM, MESS, IERR)

*Documentation_Block

***********************************************************************
*                                                                     *
*  This routine performs a standard program stop. It should always    *
*  be used to stop the program.                                       *
*                                                                     *
*Start_verbatim                                                       *
*                                                                     *
*  Inputs:                                                            *
*      FROM = (character*(*)) string containing name of               *
*             calling routine                                         *
*      MESS = (character*(*)) string containing user supplied         *
*             error message                                           *
*      IERR = user supplied error number                              *
*  Outputs:                                                           *
*     An error message that is written onto the unit 'IOLOG'.  The    *
* routine also issues a program stop.                                 *
*                                                                     *
*  Modified: 30-Nov-96: Message simplified and protected against      *
*                       format errors in STOPER itself (R.V.)         *
*  Created:   6-JUN-1992   John James Ryan                            *
*                                                                     *
*End_verbatim                                                         *
***********************************************************************
*End_Documentation_Block

      IMPLICIT NONE

***************************
*     Input Variables     *
***************************

      CHARACTER*(*) FROM, MESS
      INTEGER       IERR

***************************
*     Local Variables     *
***************************

      INTEGER       NLVLS
      PARAMETER    (NLVLS= 40)

      INTEGER       IOLOG
      PARAMETER    (IOLOG= 6)

************************
*  Send the messages   *
************************

      write (iolog,'(3a,i11,a/1x,a)') ' STOPER: run stopped by ', from,
     1 ' for error # ', ierr, ':', mess

*****************************
*     Print a Traceback     *
*****************************

      WRITE (IOLOG, '('' Trace-Back Follows ....'')')
      CALL TRACEQ (IOLOG, NLVLS)

****************************
*     Stop the program     *
****************************


      CALL ZEND

      END
