      SUBROUTINE STPARS (LINE,NFIELD,NFOUND,FIELDS,LENFDS)
***********************************************************************
*                                                                     *
*     STPARS (LINE, NFIELD, NFOUND, FIELDS, LENFDS)                   *
*                                                                     *
*  Created:     JUN-1988   Harry Melanson                             *
*                                                                     *
*      This subroutine is used to "Parse" a line of text, extracting  *
*      "Fields" (words separated by arbitrary numbers of spaces),     *
*      which is returned in an array.  The number of found fields     *
*      is also returned to the user; if no fields are found, a value  *
*      of zero is returned.  The length of each field is also         *
*      returned.                                                      *
*                                                                     *
*  Inputs:                                                            *
*                LINE            The Character String to be Parsed    *
*                                                                     *
*                NFIELD          The Number of Fields for which to    *
*                                search (STPARS returns after finding *
*                                this number of fields).              *
*                                                                     *
*  Outputs:                                                           *
*                NFOUND          The Number of found fields           *
*                                                                     *
*                FIELDS          Array containing the found fields.   *
*                                The dimension of this variable       *
*                                should be greater than or equal to   *
*                                the number of fields requested in    *
*                                the parsing.                         *
*                                                                     *
*                LENFDS          Array containing the lengths of the  *
*                                found fields.                        *
*                                The dimension of this variable       *
*                                should be greater than or equal to   *
*                                the number of fields requested in    *
*                                the parsing.                         *
*                                                                     *
***********************************************************************

C     Description: above
C     =============
C  Routine stolen from E665 SHELL to handle input cards better than FFREAD
C
C     Arguments:
C     ===========
C     STRING
C
C     Implicit inputs, outputs, side effects:-
C     ========================================
C     none
C
C     Author:  above
C     =======
C
C     Creation Date: above
C     ===========================
C
C     Revisions:
C     ==========
C     Date       Name       Description
C     ---------  -------    --------------------------------------------
C
C     23 Oct 92  R. V.      Separated from GE_...
C      1 Jun 92  C. Parsons Moved from GPH into GE_ALL_THE_REST

      IMPLICIT NONE

      CHARACTER*(*) LINE,FIELDS(*)
      INTEGER NFIELD,LENFDS(*),NFOUND
      INTEGER ICHAR,IFIELD,IPOS,LENLIN,LENFLD,START

******************************
*   INITIALIZE FIELDS        *
******************************

      NFOUND=0
      LENFLD = LEN (FIELDS(1))
      DO 10 IFIELD=1,NFIELD
        FIELDS (IFIELD) = ' '
   10 CONTINUE

*********************************************
*     GET TO THE FIRST NON-BLANK CHARACTER  *
*********************************************

      LENLIN=LEN(LINE)
      DO 100 IPOS=1,LENLIN
      IF (LINE(IPOS:IPOS).NE.' ') THEN
        START=IPOS
        GOTO110
      ENDIF
  100 CONTINUE
      RETURN

********************************************
*   PARSE THE LINE, PULLING OUT THE FIELDS *
********************************************

  110 CONTINUE
      ICHAR=0
      IFIELD=1
      DO 120 IPOS=START,LENLIN
      IF (LINE(IPOS:IPOS).NE.' ') THEN
        ICHAR=ICHAR+1
        IF (ICHAR.LE.LENFLD) THEN
          FIELDS(IFIELD)(ICHAR:ICHAR)=LINE(IPOS:IPOS)
        ENDIF
      ELSE
        IF (ICHAR.NE.0) THEN
          IF (ICHAR.LE.LENFLD) THEN
            LENFDS(IFIELD)=ICHAR
          ELSE
            LENFDS(IFIELD)=LENFLD
          ENDIF
          ICHAR=0
          IFIELD=IFIELD+1
          NFOUND=NFOUND+1
          IF (IFIELD.GT.NFIELD) RETURN
        ENDIF
      ENDIF
  120 CONTINUE

      RETURN
      END
