#ifndef _PhStuff_INCLUDED_
#define _PhStuff_INCLUDED_

///////////////////////////////////////////////////////////////////////
//                                                                   //
//    TPhStuff                                                       //
//                                                                   //
//  Interface class to some Fortran CERNlib stuff                    // 
// 
// $Id: TPhStuff.h,v 1.2 1999/02/10 22:21:13 decowski Exp $
// 
///////////////////////////////////////////////////////////////////////

// ROOT classes

#include "TObject.h"

class TPhStuff : public TObject {



public:

  TPhStuff() { };
  virtual ~TPhStuff() {};

  static Int_t  Polint(Float_t xarr[], Float_t yarr[], Int_t n, 
		      Float_t x, Float_t *y, Float_t *dy);

  static Int_t  Locate(Float_t xx_arr[], UInt_t n, Float_t x);
  static void   InterPol1D(Float_t xarr[], Float_t yarr[], Int_t n, Int_t m, 
			   Float_t x, Float_t *y, Float_t *dy);
  static void   InterPol2D(Float_t xarr1[], Float_t xarr2[], Float_t *yarr[], 
			  Int_t m, Int_t n, Int_t dim, Float_t x1, Float_t x2, 
			  Float_t *y, Float_t *dy);

  virtual Float_t       GetProb(Float_t chi2, Float_t ndof);
  virtual Float_t       gammq(Float_t a,Float_t x);
  virtual void          gcf(Float_t *gammcf,Float_t a,Float_t x,Float_t *gln);
  virtual Float_t       gammln(Float_t xx);
  virtual void          gser(Float_t *gamser,Float_t a,Float_t x,Float_t *gln);
  virtual void          InvCovar(Float_t *covar,Int_t N);
 
private:

public:

    ClassDef(TPhStuff,1) // Collection of mostly CERNlib stuff. 

};

#endif



